package disks

import (
	"context"
	"encoding/json"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// PresentRequest struct to present disk to node
type PresentRequest struct {
	// ID of the disk to present
	// Required: true
	DiskID uint64 `url:"diskId" json:"diskId" validate:"required"`

	// ID of the node to present disk to
	// Required: true
	NodeID uint64 `url:"nodeId" json:"nodeId" validate:"required"`
}

type wrapperPresentRequest struct {
	PresentRequest

	AsyncMode bool `url:"async_mode" json:"async_mode"`
}

// Present presents disk to node
func (d Disks) Present(ctx context.Context, req PresentRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/disks/present"

	wrappedReq := wrapperPresentRequest{
		PresentRequest: req,
		AsyncMode:      false,
	}

	res, err := d.client.DecortApiCall(ctx, http.MethodPost, url, wrappedReq)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// PresentAsync presents disk to node in async mode
func (d Disks) PresentAsync(ctx context.Context, req PresentRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudbroker/disks/present"

	wrappedReq := wrapperPresentRequest{
		PresentRequest: req,
		AsyncMode:      true,
	}

	res, err := d.client.DecortApiCall(ctx, http.MethodPost, url, wrappedReq)
	if err != nil {
		return "", err
	}

	var result string
	if err := json.Unmarshal(res, &result); err != nil {
		return "", err
	}

	return result, nil
}
